from wtforms import MultipleFileField, SelectField, StringField
from wtforms.validators import InputRequired

from CTFd.forms import BaseForm
from CTFd.forms.fields import SubmitField


class ChallengeSearchForm(BaseForm):
    field = SelectField(
        "Champ de recherche",
        choices=[
            ("name", "Nom"),
            ("id", "ID"),
            ("category", "Catégorie"),
            ("type", "Type"),
        ],
        default="name",
        validators=[InputRequired()],
    )
    q = StringField("Paramètre", validators=[InputRequired()])
    submit = SubmitField("Recherche")


class ChallengeFilesUploadForm(BaseForm):
    file = MultipleFileField(
        "Envoyer des fichiers",
        description="Joindre plusieurs fichiers à l'aide de CTRL+Click or Cmd+Click.",
        validators=[InputRequired()],
    )
    submit = SubmitField("Envoyer")
