from wtforms import BooleanField, RadioField, StringField, TextAreaField
from wtforms.validators import InputRequired

from CTFd.forms import BaseForm
from CTFd.forms.fields import SubmitField


class NotificationForm(BaseForm):
    title = StringField("Titre", description="Titre de notification")
    content = TextAreaField(
        "Contenu",
        description="Contenu de la notification. Peut être composé de HTML et/ou de Markdown.",
    )
    type = RadioField(
        "Type de notification",
        choices=[("toast", "Toast"), ("alert", "Alerte"), ("background", "Arrière-plan")],
        default="toast",
        description="Quel type de notification les utilisateurs reçoivent",
        validators=[InputRequired()],
    )
    sound = BooleanField(
        "Jouer un son",
        default=True,
        description="Jouer un son pour les utilisateurs lorsqu'ils reçoivent la notification",
    )
    submit = SubmitField("Soumettre")
