from wtforms import (
    BooleanField,
    HiddenField,
    MultipleFileField,
    SelectField,
    StringField,
    TextAreaField,
)
from wtforms.validators import InputRequired

from CTFd.forms import BaseForm


class PageEditForm(BaseForm):
    title = StringField(
        "Titre", description="Ceci est le titre indiqué sur la barre de navigation"
    )
    route = StringField(
        "Route",
        description="Il s'agit de l'itinéraire URL dans lequel votre page sera. Vous pouvez également entrer des liens pour lier vers cette page.",
    )
    draft = BooleanField("Brouillon")
    hidden = BooleanField("Caché")
    auth_required = BooleanField("Authentification requise")
    content = TextAreaField("Contenu")
    format = SelectField(
        "format",
        choices=[("markdown", "Markdown"), ("html", "HTML")],
        default="markdown",
        validators=[InputRequired()],
        description="Le format utilisé pour compiler la page",
    )
    link_target = SelectField(
        "Cible",
        choices=[("", "Page actuelle"), ("_blank", "Nouvel onglet")],
        default="",
        validators=[],
        description="Page de contexte à ouvrir",
    )


class PageFilesUploadForm(BaseForm):
    file = MultipleFileField(
        "Envoyer des fichiers",
        description="Joindre plusieurs fichiers à l'aide CTRL+Click or Cmd+Click.",
        validators=[InputRequired()],
    )
    type = HiddenField("Type de page", default="page", validators=[InputRequired()])
