from wtforms import SelectField, StringField
from wtforms.validators import InputRequired

from CTFd.forms import BaseForm
from CTFd.forms.fields import SubmitField


class SubmissionSearchForm(BaseForm):
    field = SelectField(
        "Champ de recherche",
        choices=[
            ("provided", "Fourni"),
            ("id", "ID"),
            ("account_id", "ID de compte"),
            ("challenge_id", "ID de défi"),
            ("challenge_name", "Nom du défi"),
        ],
        default="provided",
        validators=[InputRequired()],
    )
    q = StringField("Paramètre", validators=[InputRequired()])
    submit = SubmitField("Recherche")
