import "./main";
import CTFd from "../compat/CTFd";
import $ from "jquery";
import "../compat/json";
import { ezAlert, ezQuery } from "../compat/ezq";

function deleteSelectedTeams(_event) {
  let teamIDs = $("input[data-team-id]:checked").map(function () {
    return $(this).data("team-id");
  });
  let target = teamIDs.length === 1 ? "team" : "teams";

  ezQuery({
    title: "Supprimer les équipes",
    body: `Êtes-vous certain de vouloir supprimer ${teamIDs.length} ${target}?`,
    success: function () {
      const reqs = [];
      for (var teamID of teamIDs) {
        reqs.push(
          CTFd.fetch(`/api/v1/teams/${teamID}`, {
            method: "DELETE",
          }),
        );
      }
      Promise.all(reqs).then((_responses) => {
        window.location.reload();
      });
    },
  });
}

function bulkEditTeams(_event) {
  let teamIDs = $("input[data-team-id]:checked").map(function () {
    return $(this).data("team-id");
  });

  ezAlert({
    title: "Modifier les équipes",
    body: $(`
    <form id="teams-bulk-edit">
      <div class="form-group">
        <label>Banni</label>
        <select name="banned" data-initial="">
          <option value="">--</option>
          <option value="true">Vrai</option>
          <option value="false">Faux</option>
        </select>
      </div>
      <div class="form-group">
        <label>Caché</label>
        <select name="hidden" data-initial="">
          <option value="">--</option>
          <option value="true">Vrai</option>
          <option value="false">Faux</option>
        </select>
      </div>
    </form>
    `),
    button: "Soumettre",
    success: function () {
      let data = $("#teams-bulk-edit").serializeJSON(true);
      const reqs = [];
      for (var teamID of teamIDs) {
        reqs.push(
          CTFd.fetch(`/api/v1/teams/${teamID}`, {
            method: "PATCH",
            body: JSON.stringify(data),
          }),
        );
      }
      Promise.all(reqs).then((_responses) => {
        window.location.reload();
      });
    },
  });
}

$(() => {
  $("#teams-delete-button").click(deleteSelectedTeams);
  $("#teams-edit-button").click(bulkEditTeams);
});
