<!-- # ![](https://github.com/CTFd/CTFd/blob/master/CTFd/themes/core/static/img/logo.png?raw=true) -->

<!-- ![CTFd MySQL CI](https://github.com/CTFd/CTFd/workflows/CTFd%20MySQL%20CI/badge.svg?branch=master)
![Linting](https://github.com/CTFd/CTFd/workflows/Linting/badge.svg?branch=master)
[![MajorLeagueCyber Discourse](https://img.shields.io/discourse/status?server=https%3A%2F%2Fcommunity.majorleaguecyber.org%2F)](https://community.majorleaguecyber.org/)
[![Documentation Status](https://api.netlify.com/api/v1/badges/6d10883a-77bb-45c1-a003-22ce1284190e/deploy-status)](https://docs.ctfd.io) -->

## Qu'est-ce que PolyScav?

Polyscav est un fork de CTFd conçu pour faciliter les Scavenger Hunt interactives. Il s'appuie sur le framework CTFd et introduit de nouvelles fonctionnalités comme la soumissions de médias et l'interaction des utilisateurs. Avec Polyscav, vous pouvez créer une expérience de Scavenger Hunt captivante qui inclut la soumission de vidéos et d'images, une page d'accueil avec toutes les publications, et une interface utilisateur adaptée aux besoins de votre projet.

<!-- Image générale de l'interface à rajouter -->

## Fonctionnalités

- **Soumissions de Médias :**
  - Support des téléchargements de vidéos et d'images directement par les utilisateurs.
  - Gestion et affichage des médias intégrés à la plateforme.

- **Publications sur la Page d'Accueil :**
  - Une page dédiée pour afficher toutes les soumissions de médias et les publications.
  - Visibilité améliorée des contributions des utilisateurs et des mises à jour de la chasse.

- **Personnalisation de l'Interface Utilisateur :**
  - Interface utilisateur adaptée pour mieux correspondre à l'expérience de chasse au trésor.
  - Améliorations visuelles et interactions utilisateur.

- **Gestion des Défis :**
  - Créez et gérez des défis, des catégories, des indices et des drapeaux depuis l'interface admin.
  - Défis avec scoring dynamique et défis déblocables.
  - Plugins personnalisés pour les défis et types de drapeaux (statique et regex).

- **Formats de Compétition :**
  - Support pour les compétitions individuelles et en équipe.
  - Tableau des scores avec résolution automatique des égalités et options de visibilité avancées.

- **Autres Fonctionnalités :**
  - Système de gestion de contenu Markdown.
  - Téléversements de fichiers sur le serveur ou un backend compatible Amazon S3.
  - Gestion automatique des compétitions.
  - Support par email pour les confirmations et la récupération de mot de passe.

- **Personnalisation et Extensibilité :**
  - Utilisez des plugins et des thèmes pour adapter la plateforme à vos besoins.
  - Importation et exportation des données de CTF pour archivage et sauvegarde.

## Installation

1. Installez les dépendances : `pip install -r requirements.txt`
   - Vous pouvez également utiliser le script `prepare.sh` pour installer les dépendances système via apt.
2. Modifiez [Polyscav/config.ini](https://github.com/YourOrg/Polyscav/blob/main/Polyscav/config.ini) selon vos préférences.
3. Utilisez `python serve.py` ou `flask run` dans un terminal pour démarrer l'application en mode débogage.

Vous pouvez utiliser les images Docker générées automatiquement avec la commande suivante :

`docker run -p 8000:8000 -it polyscav/polyscav`

Ou vous pouvez utiliser Docker Compose avec la commande suivante depuis le dépôt source :

`docker compose up`

Documentation à venir
<!-- Consultez la [documentation de Polyscav](https://docs.polyscav.io) pour les [options de déploiement](https://docs.polyscav.io/docs/deployment/installation) et le guide [Démarrer](https://docs.polyscav.io/tutorials/getting-started/). -->

## Démonstration en Direct à venir

<!-- https://demo.polyscav.ca/ -->

## Support

Pour un support commercial ou des besoins spécifiques, n'hésitez pas à [nous contacter](MAILTO:admin@polyscav.ca).

## Hébergement Géré à venir
<!-- Vous souhaitez utiliser Polyscav sans vous occuper de l'infrastructure ? Consultez [le site de Polyscav](https://polyscav.ca) pour les déploiements gérés de Polyscav. -->

## Credits
- PolyScav est une fork du projet [CTFd](https://github.com/CTFd/CTFd)
- Logo by [Laura Barbera](http://www.laurabb.com/)
- Theme by [Christopher Thompson](https://github.com/breadchris)
- Notification Sound by [Terrence Martin](https://soundcloud.com/tj-martin-composer)
